Index: trunk/gui/scripts/scroller.tcl
===================================================================
--- trunk/gui/scripts/scroller.tcl	(revision 6716)
+++ trunk/gui/scripts/scroller.tcl	(revision 1)
@@ -1,3 +1,2 @@
-# -*- mode: tcl; indent-tabs-mode: nil -*-
 # ----------------------------------------------------------------------
 #  COMPONENT: scroller - adds scrollbars to any standard Tk widget
@@ -10,8 +9,5 @@
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2012  HUBzero Foundation, LLC
-#
-#  See the file "license.terms" for information on usage and
-#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
+#  Copyright (c) 2004  Purdue Research Foundation, West Lafayette, IN
 # ======================================================================
 package require Itk
@@ -19,6 +15,4 @@
 option add *Scroller.xScrollMode off widgetDefault
 option add *Scroller.yScrollMode auto widgetDefault
-option add *Scroller.xScrollSide bottom widgetDefault
-option add *Scroller.yScrollSide right widgetDefault
 option add *Scroller.width 0 widgetDefault
 option add *Scroller.height 0 widgetDefault
@@ -29,11 +23,8 @@
     itk_option define -xscrollmode xScrollMode XScrollMode ""
     itk_option define -yscrollmode yScrollMode YScrollMode ""
-    itk_option define -xscrollside xScrollSide XScrollSide ""
-    itk_option define -yscrollside yScrollSide YScrollSide ""
     itk_option define -width width Width 0
     itk_option define -height height Height 0
 
     constructor {args} { # defined below }
-    destructor { # defined below }
 
     public method contents {{frame "!@#query"}}
@@ -41,14 +32,12 @@
     protected method _widget2sbar {which args}
     protected method _fixsbar {which {state ""}}
-    protected method _fixframe {which}
-    protected method _fixsize {}
-    protected method _lock {option which}
-
-    private variable _dispatcher "" ;# dispatcher for !events
+    protected method _fixframe {}
+    protected method _lock {option}
+
     private variable _contents ""   ;# widget being controlled
     private variable _frame ""      ;# for "contents frame" calls
-    private variable _lock          ;# for _lock on x/y scrollbar
-}
-
+    private variable _lock 0        ;# for _lock on x-scrollbar
+}
+                                                                                
 itk::usual Scroller {
     keep -background -activebackground -activerelief
@@ -62,20 +51,4 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::Scroller::constructor {args} {
-    array set _lock { x 0 y 0 }
-
-    Rappture::dispatcher _dispatcher
-
-    $_dispatcher register !fixframe-inner
-    $_dispatcher dispatch $this !fixframe-inner \
-        "[itcl::code $this _fixframe inner]; list"
-
-    $_dispatcher register !fixframe-outer
-    $_dispatcher dispatch $this !fixframe-outer \
-        "[itcl::code $this _fixframe outer]; list"
-
-    $_dispatcher register !fixsize
-    $_dispatcher dispatch $this !fixsize \
-        "[itcl::code $this _fixsize]; list"
-
     itk_component add xsbar {
         scrollbar $itk_interior.xsbar -orient horizontal
@@ -85,23 +58,8 @@
     }
 
-    # we don't fix scrollbars when window is withdrawn, so
-    # fix them whenever a window pops up
-    bind $itk_component(hull) <Map> "
-        [itcl::code $this _fixsbar x]
-        [itcl::code $this _fixsbar y]
-    "
-
-    grid rowconfigure $itk_component(hull) 1 -weight 1
-    grid columnconfigure $itk_component(hull) 1 -weight 1
+    grid rowconfigure $itk_component(hull) 0 -weight 1
+    grid columnconfigure $itk_component(hull) 0 -weight 1
 
     eval itk_initialize $args
-}
-
-# ----------------------------------------------------------------------
-# DESTRUCTOR
-# ----------------------------------------------------------------------
-itcl::body Rappture::Scroller::destructor {} {
-    after cancel [itcl::code $this _lock reset x]
-    after cancel [itcl::code $this _lock reset y]
 }
 
@@ -118,7 +76,4 @@
 itcl::body Rappture::Scroller::contents {{widget "!@#query"}} {
     if {$widget == "!@#query"} {
-        if {$_contents == $_frame} {
-            return $_frame.f
-        }
         return $_contents
     }
@@ -145,13 +100,6 @@
     if {$widget == "frame"} {
         if {$_frame == ""} {
-            set _frame [canvas $itk_component(hull).ifr -highlightthickness 0]
-            frame $_frame.f
-            $_frame create window 0 0 -anchor nw -window $_frame.f -tags frame
-            bind $_frame.f <Map> \
-                [itcl::code $_dispatcher event -idle !fixframe-inner]
-            bind $_frame.f <Configure> \
-                [itcl::code $_dispatcher event -idle !fixframe-inner]
-            bind $_frame <Configure> \
-                [itcl::code $_dispatcher event -idle !fixframe-outer]
+            set _frame [canvas $itk_component(hull).ifr]
+            bind $_frame <Configure> [itcl::code $this _resizeframe]
         }
         set widget $_frame
@@ -162,5 +110,5 @@
     #
     contents ""
-    grid $widget -row 1 -column 1 -sticky nsew
+    grid $widget -row 0 -column 0 -sticky nsew
     $widget configure \
         -xscrollcommand [itcl::code $this _widget2sbar x] \
@@ -171,15 +119,4 @@
     set _contents $widget
 
-    if {[string equal "x11" [tk windowingsystem]]} {
-        bind ${widget} <4> { %W yview scroll -5 units }
-        bind ${widget} <5> { %W yview scroll 5 units }
-    } else {
-        bind ${widget} <MouseWheel> {
-            %W yview scroll [expr {- (%D / 120) * 4}] units
-        }
-    }
-    if {$widget == $_frame} {
-        return $_frame.f
-    }
     return $widget
 }
@@ -211,15 +148,6 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::Scroller::_fixsbar {which {state ""}} {
-    if {![winfo ismapped $itk_component(hull)]} {
-        #
-        # If we're not on yet screen, bail out!  This keeps bad
-        # numbers (from an empty or partially constructed widget)
-        # from prematurely influencing the scrollbar.
-        #
-        return
-    }
-
     if {$state == ""} {
-        switch -- [string tolower $itk_option(-${which}scrollmode)] {
+        switch -- $itk_option(-${which}scrollmode) {
             on - 1 - true - yes  { set state 1 }
             off - 0 - false - no { set state 0 }
@@ -233,32 +161,4 @@
                 }
             }
-            default {
-                set state 0
-            }
-        }
-    }
-
-    set row 0
-    set col 0
-    switch -- [string tolower $itk_option(-${which}scrollside)] {
-        top {
-            set row 0
-            set col 1
-        }
-        bottom {
-            set row 2
-            set col 1
-        }
-        left {
-            set row 1
-            set col 0
-        }
-        right {
-            set row 1
-            set col 2
-        }
-        default {
-            set row 0
-            set col 0
         }
     }
@@ -268,13 +168,9 @@
         x {
             if {$state} {
-                if {$col == 1} {
-                    grid $itk_component(xsbar) -row $row -column $col -sticky ew
-                }
+                grid $itk_component(xsbar) -row 1 -column 0 -sticky ew
+                _lock set
             } else {
-                # handle the lock on the "forget" side, so scrollbar
-                # tends to appear, rather than disappear
-                if {![_lock active x]} {
+                if {![_lock active]} {
                     grid forget $itk_component(xsbar)
-                    _lock set x
                 }
             }
@@ -282,14 +178,7 @@
         y {
             if {$state} {
-                if {$row == 1} {
-                    grid $itk_component(ysbar) -row $row -column $col -sticky ns
-                }
+                grid $itk_component(ysbar) -row 0 -column 1 -sticky ns
             } else {
-                # handle the lock on the "forget" side, so scrollbar
-                # tends to appear, rather than disappear
-                if {![_lock active y]} {
-                    grid forget $itk_component(ysbar)
-                    _lock set y
-                }
+                grid forget $itk_component(ysbar)
             }
         }
@@ -298,5 +187,5 @@
 
 # ----------------------------------------------------------------------
-# USAGE: _fixframe <which>
+# USAGE: _fixframe
 #
 # Invoked automatically whenever the canvas representing the "frame"
@@ -304,58 +193,12 @@
 # to the new size.
 # ----------------------------------------------------------------------
-itcl::body Rappture::Scroller::_fixframe {which} {
-    switch -- $which {
-        inner {
-            set w [winfo reqwidth $_frame.f]
-            set h [winfo reqheight $_frame.f]
-            $_frame configure -scrollregion [list 0 0 $w $h]
-            _fixframe outer
-            _lock reset x
-            _lock reset y
-            $_dispatcher event -idle !fixsize
-        }
-        outer {
-            if {[winfo width $_frame] > [winfo reqwidth $_frame.f]} {
-                $_frame itemconfigure frame -width [winfo width $_frame]
-            } else {
-                $_frame itemconfigure frame -width 0
-            }
-            if {[winfo height $_frame] > [winfo reqheight $_frame.f]} {
-                $_frame itemconfigure frame -height [winfo height $_frame]
-            } else {
-                $_frame itemconfigure frame -height 0
-            }
-        }
-    }
-}
-
-# ----------------------------------------------------------------------
-# USAGE: _fixsize
-#
-# Used internally to update the size options for the widget
-# whenever the -width/-height options change.
-# ----------------------------------------------------------------------
-itcl::body Rappture::Scroller::_fixsize {} {
-    if {$itk_option(-width) == "0" && $itk_option(-height) == "0"} {
-        # for default size, let the frame being controlled set the size
-        grid propagate $itk_component(hull) yes
-        if {$_frame == "$itk_component(hull).ifr"} {
-            set w [expr {[winfo reqwidth $_frame.f]+2}]
-            set h [winfo reqheight $_frame.f]
-            $_frame configure -width $w -height $h
-        }
-    } else {
-        # for specific size, set the overall size of the widget
-        grid propagate $itk_component(hull) no
-        set w $itk_option(-width); if {$w == "0"} { set w 1i }
-        set h $itk_option(-height); if {$h == "0"} { set h 1i }
-        component hull configure -width $w -height $h
-    }
-}
-
-# ----------------------------------------------------------------------
-# USAGE: _lock set <which>
-# USAGE: _lock reset <which>
-# USAGE: _lock active <which>
+itcl::body Rappture::Scroller::_fixframe {} {
+    $_frame configure -scrollregion [$_frame bbox all]
+}
+
+# ----------------------------------------------------------------------
+# USAGE: _lock set
+# USAGE: _lock reset
+# USAGE: _lock active
 #
 # Used internally to lock out vibrations when the x-scrollbar pops
@@ -367,16 +210,16 @@
 # up.
 # ----------------------------------------------------------------------
-itcl::body Rappture::Scroller::_lock {option which} {
+itcl::body Rappture::Scroller::_lock {option} {
     switch -- $option {
         set {
-            set _lock($which) 1
-            after cancel [itcl::code $this _lock reset $which]
-            after 50 [itcl::code $this _lock reset $which]
+            set _lock 1
+            after cancel [itcl::code $this _lock reset]
+            after 50 [itcl::code $this _lock reset]
         }
         reset {
-            set _lock($which) 0
+            set _lock 0
         }
         active {
-            return $_lock($which)
+            return $_lock
         }
         default {
@@ -401,25 +244,17 @@
 
 # ----------------------------------------------------------------------
-# OPTION: -xscrollside
-# ----------------------------------------------------------------------
-itcl::configbody Rappture::Scroller::xscrollside {
-    _fixsbar x
-}
-
-# ----------------------------------------------------------------------
-# OPTION: -yscrollside
-# ----------------------------------------------------------------------
-itcl::configbody Rappture::Scroller::yscrollside {
-    _fixsbar y
-}
-
-# ----------------------------------------------------------------------
 # OPTION: -width
 # ----------------------------------------------------------------------
 itcl::configbody Rappture::Scroller::width {
-    # check for proper value
-    winfo pixels $itk_component(hull) $itk_option(-width)
-
-    $_dispatcher event -idle !fixsize
+    if {$itk_option(-width) == "0"} {
+        if {$itk_option(-width) == "0"} {
+            grid propagate $itk_component(hull) yes
+        } else {
+            component hull configure -width 1i
+        }
+    } else {
+        grid propagate $itk_component(hull) no
+        component hull configure -width $itk_option(-width)
+    }
 }
 
@@ -428,7 +263,13 @@
 # ----------------------------------------------------------------------
 itcl::configbody Rappture::Scroller::height {
-    # check for proper value
-    winfo pixels $itk_component(hull) $itk_option(-height)
-
-    $_dispatcher event -idle !fixsize
-}
+    if {$itk_option(-height) == "0"} {
+        if {$itk_option(-height) == "0"} {
+            grid propagate $itk_component(hull) yes
+        } else {
+            component hull configure -height 1i
+        }
+    } else {
+        grid propagate $itk_component(hull) no
+        component hull configure -height $itk_option(-height)
+    }
+}
Index: trunk/gui/scripts/spectrum.tcl
===================================================================
--- trunk/gui/scripts/spectrum.tcl	(revision 6716)
+++ trunk/gui/scripts/spectrum.tcl	(revision 1)
@@ -1,3 +1,2 @@
-# -*- mode: tcl; indent-tabs-mode: nil -*-
 # ----------------------------------------------------------------------
 #  COMPONENT: spectrum - maps a range of real values onto a color
@@ -15,8 +14,5 @@
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2012  HUBzero Foundation, LLC
-#
-#  See the file "license.terms" for information on usage and
-#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
+#  Copyright (c) 2004  Purdue Research Foundation, West Lafayette, IN
 # ======================================================================
 package require Itk
@@ -37,9 +33,6 @@
     private variable _gvals ""      ;# list of green components along axis
     private variable _bvals ""      ;# list of blue components along axis
-    private variable _spectrum 0    ;# use continuous visible spectrum
-    private variable _specv0 0      ;# minimum value
-    private variable _specw0 0      ;# wavelength for minimum
-}
-
+}
+                                                                                
 # ----------------------------------------------------------------------
 # CONSTRUCTOR
@@ -65,35 +58,4 @@
 itcl::body Rappture::Spectrum::insert {args} {
     set changed 0
-
-    # special case. Two values in nm, then use
-    # spectrum instead of gradient.
-    if {[llength $args] == 4} {
-        set cnt 0
-        foreach {value color} $args {
-            if {[string match "*nm" $color]} {
-                incr cnt
-            }
-        }
-        if {$cnt == 2} {
-            set val0 [lindex $args 0]
-            set color0 [string trimright [lindex $args 1] "nm"]
-            set val1 [lindex $args 2]
-            set color1 [string trimright [lindex $args 3] "nm"]
-
-            if {"" != $units} {
-                set val0 [Rappture::Units::convert $val0 \
-                              -context $units -to $units -units off]
-                set val1 [Rappture::Units::convert $val1 \
-                              -context $units -to $units -units off]
-            }
-
-            set _spectrum [expr (double($color1) - double($color0)) \
-                           / (double($val1) - double($val0))]
-            set _specv0 $val0
-            set _specw0 $color0
-            return
-        }
-    }
-
     foreach {value color} $args {
         if {"" != $units} {
@@ -101,5 +63,6 @@
                 -context $units -to $units -units off]
         }
-        foreach {r g b} [Rappture::color::RGB $color] { break }
+        foreach {r g b} [winfo rgb . $color] { break }
+
         set i 0
         foreach v $_axis {
@@ -187,5 +150,5 @@
     while {[llength $args] > 0} {
         set first [lindex $args 0]
-        if {[regexp {^-[a-zA-Z]} $first]} {
+        if {[string index $first 0] == "-"} {
             set what $first
             set args [lrange $args 1 end]
@@ -197,41 +160,11 @@
         error "wrong # args: should be \"get ?-color|-fraction? ?value?\""
     }
-
     set value [lindex $args 0]
 
-    switch -- [lindex $value 0] {
-        gaussian {
-            set value [lindex $value 1]
-            if {$units != ""} {
-                set value [Rappture::Units::convert $value \
-                -context $units -to $units -units off]
-            }
-        }
-        uniform {
-            set min [lindex $value 1]
-            set max [lindex $value 2]
-            if {$units != ""} {
-                set min [Rappture::Units::convert $min \
-                -context $units -to $units -units off]
-                set max [Rappture::Units::convert $max \
-                -context $units -to $units -units off]
-            }
-            set value [expr {0.5 * ($min + $max)}]
-        }
-        default {
-            if {$units != ""} {
-                set value [Rappture::Units::convert $value \
-                -context $units -to $units -units off]
-            }
-        }
-    }
+    set value [Rappture::Units::convert $value \
+        -context $units -to $units -units off]
 
     switch -- $what {
         -color {
-            if {$_spectrum != 0} {
-                # continuous spectrum. just compute wavelength
-                set waveln [expr ($value - $_specv0) * $_spectrum + $_specw0]
-                return [Rappture::color::wave2RGB $waveln]
-            }
             set i 0
             set ilast ""
Index: trunk/gui/scripts/tempgauge.tcl
===================================================================
--- trunk/gui/scripts/tempgauge.tcl	(revision 6716)
+++ trunk/gui/scripts/tempgauge.tcl	(revision 1)
@@ -1,3 +1,2 @@
-# -*- mode: tcl; indent-tabs-mode: nil -*-
 # ----------------------------------------------------------------------
 #  COMPONENT: tempgauge - gauge for temperature values
@@ -7,29 +6,19 @@
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2012  HUBzero Foundation, LLC
-#
-#  See the file "license.terms" for information on usage and
-#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
+#  Copyright (c) 2004  Purdue Research Foundation, West Lafayette, IN
 # ======================================================================
 package require Itk
 
-option add *TemperatureGauge.sampleWidth 30 widgetDefault
-option add *TemperatureGauge.sampleHeight 20 widgetDefault
-option add *TemperatureGauge.borderWidth 2 widgetDefault
-option add *TemperatureGauge.relief sunken widgetDefault
+option add *TemperatureGauge.width 30 widgetDefault
+option add *TemperatureGauge.height 0 widgetDefault
 option add *TemperatureGauge.textBackground #cccccc widgetDefault
 option add *TemperatureGauge.valuePosition "right" widgetDefault
 option add *TemperatureGauge.editable yes widgetDefault
-option add *TemperatureGauge.state normal widgetDefault
 
 itcl::class Rappture::TemperatureGauge {
     inherit Rappture::Gauge
 
-    constructor {args} {
-        array set attrs $args
-        Rappture::Gauge::constructor -uq $attrs(-uq)
-    } {
-        eval itk_initialize -spectrum $_spectrum -units K $args
-    }
+    constructor {args} { # defined below }
+
     protected method _redraw {}
     protected method _resize {}
@@ -44,4 +33,11 @@
 
 itk::usual TemperatureGauge {
+}
+
+# ----------------------------------------------------------------------
+# CONSTRUCTOR
+# ----------------------------------------------------------------------
+itcl::body Rappture::TemperatureGauge::constructor {args} {
+    eval itk_initialize -spectrum $_spectrum -units K $args
 }
 
@@ -62,8 +58,6 @@
         $c create oval 0 0 1 1 -outline "" -tags bulbfill
         $c create oval 0 0 1 1 -outline black -tags bulboutline
-        $c create oval 0 0 1 1 -outline "" -fill "" -stipple gray50 -tags {bulbscreen screen}
         $c create rect 0 0 1 1 -outline black -fill white -tags stickoutline
         $c create rect 0 0 1 1 -outline "" -tags stickfill
-        $c create rect 0 0 1 1 -outline "" -fill "" -stipple gray50 -tags {stickscreen screen}
         $c create image 0 0 -anchor w -image "" -tags bimage
     }
@@ -97,6 +91,4 @@
         $c coords bulboutline $x [expr {$y-$bsize}] \
             [expr {$x+2*$bsize}] [expr {$y+$bsize}]
-        $c coords bulbscreen [expr {$x-1}] [expr {$y-$bsize-1}] \
-            [expr {$x+2*$bsize+1}] [expr {$y+$bsize+1}]
         $c coords bulbfill $x [expr {$y-$bsize}] \
             [expr {$x+2*$bsize}] [expr {$y+$bsize}]
@@ -107,6 +99,4 @@
         $c coords stickoutline [expr {$x0-2}] [expr {$y-$ssize}] \
             $x1 [expr {$y+$ssize}]
-        $c coords stickscreen [expr {$x0-2}] [expr {$y-$ssize}] \
-            [expr {$x1+1}] [expr {$y+$ssize+1}]
         $c coords stickfill [expr {$x0-2}] [expr {$y-$ssize+1}] \
             $xr [expr {$y+$ssize}]
@@ -114,10 +104,4 @@
         $c itemconfigure bulbfill -fill $color
         $c itemconfigure stickfill -fill $color
-    }
-
-    if {$itk_option(-state) == "disabled"} {
-        $c itemconfigure screen -fill white
-    } else {
-        $c itemconfigure screen -fill ""
     }
 }
@@ -130,6 +114,6 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::TemperatureGauge::_resize {} {
-    if {$itk_option(-samplewidth) > 0} {
-        set w $itk_option(-samplewidth)
+    if {$itk_option(-width) > 0} {
+        set w $itk_option(-width)
     } else {
         set w [winfo reqheight $itk_component(value)]
@@ -139,6 +123,6 @@
     }
 
-    if {$itk_option(-sampleheight) > 0} {
-        set h $itk_option(-sampleheight)
+    if {$itk_option(-height) > 0} {
+        set h $itk_option(-height)
     } else {
         if {$itk_option(-image) != ""} {
